Properties Methods Events Config Options Direct Link

    Observable
      Connection

# Class Ext.data.Connection

Package: | Ext.data
Defined In: | Connection.js
Class: | Connection
Subclasses: | Ajax
Extends: | Observable

The class encapsulates a connection to the page's originating domain, allowing requests to be made either to a configured URL, or to a URL specified at request time.

Requests made by this class are asynchronous, and will return immediately. No data from the server will be available to the statement immediately following the request call. To process returned data, use a success callback in the request options object, or an event listener.

### File Uploads

File uploads are not performed using normal "Ajax" techniques, that is they are not performed using XMLHttpRequests. Instead the form is submitted in the standard manner with the DOM `<form>` element temporarily modified to have its target set to refer to a dynamically generated, hidden `<iframe>` which is inserted into the document but removed after the return data has been gathered.

The server response is parsed by the browser to create the document for the IFRAME. If the server is using JSON to send the return object, then the Content-Type header must be set to "text/html" in order to tell the browser to insert the text unchanged into the document body.

Characters which are significant to an HTML parser must be sent as HTML entities, so encode "<" as "&lt;", "&" as "&amp;" etc.

The response text is retrieved from the document, and a fake XMLHttpRequest object is created containing a `responseText` property in order to conform to the requirements of event handlers and callbacks.

Be aware that file upload packets are sent with the content type multipart/form and some server technologies (notably JEE) may require some custom processing in order to retrieve parameter names and parameter values from the packet content.

Also note that it's not possible to check the response code of the hidden iframe, so the success handler will ALWAYS fire.

## Config Options

Config Options | Defined By
--- | ---
| autoAbort : Boolean Whether this request should abort any pending requests. (defaults to false) | Connection
| defaultHeaders : Object An object containing request headers which are added to each request made by this object. (defaults to undefined) | Connection
| disableCaching : Boolean True to add a unique cache-buster param to GET requests. (defaults to true) | Connection
| disableCachingParam : String Change the parameter which is sent went disabling caching through a cache buster. Defaults to '_dc' | Connection
| extraParams : Object An object containing properties which are used as extra parameters to each request made by this object. (defaults to ... An object containing properties which are used as extra parameters to each request made by this object. (defaults to undefined) | Connection

listeners : Object
A config object containing one or more event handlers to be added to this object during initialization. This should ...

A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.

DOM events from ExtJs Components

While some ExtJs Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually only done when extra value can be added. For example the DataView's `click` event passing the node clicked on. To access DOM events directly from a Component's HTMLElement, listeners must be added to the Element after the Component has been rendered. A plugin can simplify this step:

    // Plugin is configured with a listeners config object.
    // The Component is appended to the argument list of all handler functions.
    Ext.DomObserver = Ext.extend(Object, {
        constructor: function(config) {
            this.listeners = config.listeners ? config.listeners : config;
        },

        // Component passes itself into plugin's init method
        init: function(c) {
            var p, l = this.listeners;
            for (p in l) {
                if (Ext.isFunction(l[p])) {
                    l[p] = this.createHandler(l[p], c);
                } else {
                    l[p].fn = this.createHandler(l[p].fn, c);
                }
            }

            // Add the listeners to the Element immediately following the render call
            c.render = c.render.createSequence(function() {
                var e = c.getEl();
                if (e) {
                    e.on(l);
                }
            });
        },

        createHandler: function(fn, c) {
            return function(e) {
                fn.call(this, e, c);
            };
        }
    });

    var combo = new Ext.form.ComboBox({

        // Collapse combo when its element is clicked on
        plugins: [ new Ext.DomObserver({
            click: function(evt, comp) {
                comp.collapse();
            }
        })],
        store: myStore,
        typeAhead: true,
        mode: 'local',
        triggerAction: 'all'
    });

Observable

| method : String The default HTTP method to be used for requests. (defaults to undefined; if not set, but request params are present, ... The default HTTP method to be used for requests. (defaults to undefined; if not set, but request params are present, POST will be used; otherwise, GET will be used.) | Connection
| timeout : Number The timeout in milliseconds to be used for requests. (defaults to 30000) | Connection

url : String
The default URL to be used for requests to the server. Defaults to undefined. The url config may be a function which ...

The default URL to be used for requests to the server. Defaults to undefined.

The `url` config may be a function which returns the URL to use for the Ajax request. The scope (`this` reference) of the function is the `scope` option passed to the request method.

Connection

## Public Properties

This class has no public properties.

## Public Methods

Method | Defined By
--- | ---

Connection( `Object config` )
Parameters:

- `config` : Object
  a configuration object.

Returns:

- void

Connection

abort( [`Number transactionId`] ) : void
Aborts any outstanding request.
Aborts any outstanding request.
Parameters:

- `transactionId` : Number
  (Optional) defaults to the last transaction

Returns:

- void

Connection

addEvents( `Object|String o`, `string Optional.` ) : void
Adds the specified events to the list of events which this Observable may fire.
Adds the specified events to the list of events which this Observable may fire.
Parameters:

- `o` : Object|String
  Either an object with event names as properties with a value of `true` or the first event name string if multiple event names are being passed as separate parameters.
- `Optional.` : string
  Event name if multiple event names are being passed as separate parameters. Usage:

      this.addEvents('storeloaded', 'storecleared');

Returns:

- void

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object.
Appends an event handler to this object.
Parameters:

- `eventName` : String
  The name of the event to listen for.
- `handler` : Function
  The method the event invokes.
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration. properties. This may contain any of the following properties:
  - scope : Object
    The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
  - delay : Number
    The number of milliseconds to delay the invocation of the handler after the event fires.
  - single : Boolean
    True to add a handler to handle just the next firing of the event, and then remove itself.
  - buffer : Number
    Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
  - target : Observable
    Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A delayed, one-time listener.

      myDataView.on('click', this.onClick, this, {
      single: true,
      delay: 100
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      myGridPanel.on({
      'click' : {
          fn: this.onClick,
          scope: this,
          delay: 100
      },
      'mouseover' : {
          fn: this.onMouseOver,
          scope: this
      },
      'mouseout' : {
          fn: this.onMouseOut,
          scope: this
      }
      });

  Or a shorthand syntax:

      myGridPanel.on({
      'click' : this.onClick,
      'mouseover' : this.onMouseOver,
      'mouseout' : this.onMouseOut,
       scope: this
      });

Returns:

- void

Observable

enableBubble( `String/Array events` ) : void
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present....

Enables events fired by this Observable to bubble up an owner hierarchy by calling `this.getBubbleTarget()` if present. There is no implementation in the Observable base class.

This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.

Example:

    Ext.override(Ext.form.Field, {
        //  Add functionality to Field's initComponent to enable the change event to bubble
        initComponent : Ext.form.Field.prototype.initComponent.createSequence(function() {
            this.enableBubble('change');
        }),

        //  We know that we want Field's events to bubble directly to the FormPanel.
        getBubbleTarget : function() {
            if (!this.formPanel) {
                this.formPanel = this.findParentByType('form');
            }
            return this.formPanel;
        }
    });

    var myForm = new Ext.formPanel({
        title: 'User Details',
        items: [{
            ...
        }],
        listeners: {
            change: function() {
                // Title goes red if form has been modified.
                myForm.header.setStyle('color', 'red');
            }
        }
    });

Parameters:

- `events` : String/Array
  The event name to bubble, or an Array of event names.

Returns:

- void

Observable

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name). An event may be set to bubble up an Obse...

Fires the specified event with the passed parameters (minus the event name).

An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.

Parameters:

- `eventName` : String
  The name of the event to fire.
- `args` : Object...
  Variable number of parameters are passed to handlers.

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true.

Observable

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

isLoading( [`Number transactionId`] ) : Boolean
Determine whether this object has a request outstanding.
Determine whether this object has a request outstanding.
Parameters:

- `transactionId` : Number
  (Optional) defaults to the last transaction

Returns:

- `Boolean`
  True if there is an outstanding request.

Connection

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object (shorthand for addListener.)
Appends an event handler to this object (shorthand for addListener.)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration.

Returns:

- void

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- void

Observable

relayEvents( `Object o`, `Array events` ) : void
Relays selected events from the specified Observable as if the events were fired by this.
Relays selected events from the specified Observable as if the events were fired by `this`.
Parameters:

- `o` : Object
  The Observable whose events this object is to relay.
- `events` : Array
  Array of event names to relay.

Returns:

- void

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler.
Removes an event handler.
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

request( `Object options` ) : Number
Sends an HTTP request to a remote server. Important: Ajax server requests are asynchronous, and this call will return...

Sends an HTTP request to a remote server.

Important: Ajax server requests are asynchronous, and this call will return before the response has been received. Process any returned data in a callback function.

    Ext.Ajax.request({
       url: 'ajax_demo/sample.json',
       success: function(response, opts) {
          var obj = Ext.decode(response.responseText);
          console.dir(obj);
       },
       failure: function(response, opts) {
          console.log('server-side failure with status code ' + response.status);
       }
    });

To execute a callback function in the correct scope, use the `scope` option.

Parameters:

- `options` : Object
  An object which may contain the following properties:
  - url : String/Function (Optional)
    The URL to which to send the request, or a function to call which returns a URL string. The scope of the function is specified by the `scope` option. Defaults to the configured `url`.
  - params : Object/String/Function (Optional)
    An object containing properties which are used as parameters to the request, a url encoded string or a function to call to get either. The scope of the function is specified by the `scope` option.
  - method : String (Optional)
    The HTTP method to use for the request. Defaults to the configured method, or if no method was configured, "GET" if no parameters are being sent, and "POST" if parameters are being sent. Note that the method name is case-sensitive and should be all caps.
  - callback : Function (Optional)
    The function to be called upon receipt of the HTTP response. The callback is called regardless of success or failure and is passed the following parameters:
    - options : Object
      The parameter to the request call.
    - success : Boolean
      True if the request succeeded.
    - response : Object
      The XMLHttpRequest object containing the response data. See http://www.w3.org/TR/XMLHttpRequest/ for details about accessing elements of the response.
  - success : Function (Optional)
    The function to be called upon success of the request. The callback is passed the following parameters:
    - response : Object
      The XMLHttpRequest object containing the response data.
    - options : Object
      The parameter to the request call.
  - failure : Function (Optional)
    The function to be called upon failure of the request. The callback is passed the following parameters:
    - response : Object
      The XMLHttpRequest object containing the response data.
    - options : Object
      The parameter to the request call.
  - scope : Object (Optional)
    The scope in which to execute the callbacks: The "this" object for the callback function. If the `url`, or `params` options were specified as functions from which to draw values, then this also serves as the scope for those function calls. Defaults to the browser window.
  - timeout : Number (Optional)
    The timeout in milliseconds to be used for this request. Defaults to 30 seconds.
  - form : Element/HTMLElement/String (Optional)
    The `<form>` Element or the id of the `<form>` to pull parameters from.
  - isUpload : Boolean (Optional)
    Only meaningful when used with the `form` option.

    True if the form object is a file upload (will be set automatically if the form was configured with `enctype` "multipart/form-data").

    File uploads are not performed using normal "Ajax" techniques, that is they are not performed using XMLHttpRequests. Instead the form is submitted in the standard manner with the DOM `<form>` element temporarily modified to have its target set to refer to a dynamically generated, hidden `<iframe>` which is inserted into the document but removed after the return data has been gathered.

    The server response is parsed by the browser to create the document for the IFRAME. If the server is using JSON to send the return object, then the Content-Type header must be set to "text/html" in order to tell the browser to insert the text unchanged into the document body.

    The response text is retrieved from the document, and a fake XMLHttpRequest object is created containing a `responseText` property in order to conform to the requirements of event handlers and callbacks.

    Be aware that file upload packets are sent with the content type multipart/form and some server technologies (notably JEE) may require some custom processing in order to retrieve parameter names and parameter values from the packet content.

  - headers : Object (Optional)
    Request headers to set for the request.
  - xmlData : Object (Optional)
    XML document to use for the post. Note: This will be used instead of params for the post data. Any params will be appended to the URL.
  - jsonData : Object/String (Optional)
    JSON data to use as the post. Note: This will be used instead of params for the post data. Any params will be appended to the URL.
  - disableCaching : Boolean (Optional)
    True to add a unique cache-buster param to GET requests.

  The options object may also contain any other property which might be needed to perform postprocessing in a callback because it is passed to callback functions.

Returns:

- `Number`
  transactionId The id of the server transaction. This may be used to cancel the request.

Connection

resumeEvents() : void
Resume firing events. (see suspendEvents) If events were suspended using the queueSuspended parameter, then all event...
Resume firing events. (see suspendEvents) If events were suspended using the `queueSuspended` parameter, then all events fired during event suspension will be sent to any listeners now.
Parameters:

- None.

Returns:

- void

Observable

suspendEvents( `Boolean queueSuspended` ) : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- `queueSuspended` : Boolean
  Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events;

Returns:

- void

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler (shorthand for removeListener.)
Removes an event handler (shorthand for removeListener.)
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

## Public Events

Event | Defined By
--- | ---

beforerequest : ( `Connection conn`, `Object options` )
Fires before a network request is made to retrieve a data object.
Fires before a network request is made to retrieve a data object.
Listeners will be called with the following arguments:

- `conn` : Connection
  This Connection object.
- `options` : Object
  The options config object passed to the request method.

Connection

requestcomplete : ( `Connection conn`, `Object response`, `Object options` )
Fires if the request was successfully completed.
Fires if the request was successfully completed.
Listeners will be called with the following arguments:

- `conn` : Connection
  This Connection object.
- `response` : Object
  The XHR object containing the response data. See The XMLHttpRequest Object for details.
- `options` : Object
  The options config object passed to the request method.

Connection

requestexception : ( `Connection conn`, `Object response`, `Object options` )
Fires if an error HTTP status was returned from the server. See <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-...
Fires if an error HTTP status was returned from the server. See HTTP Status Code Definitions for details of HTTP status codes.
Listeners will be called with the following arguments:

- `conn` : Connection
  This Connection object.
- `response` : Object
  The XHR object containing the response data. See The XMLHttpRequest Object for details.
- `options` : Object
  The options config object passed to the request method.

Connection